structure dut = struct
local
  open SmlMC_head
in
val with_timing = false
val model_check = false

datatype Component =
  Buffer of { cnt:int }

val buffer = ref(Buffer{cnt=0})
val components = #[ buffer ]
val (e1,e2) = (nop(),nop())

fun get_b (ref(Buffer d)) = d

val events = init_ev
[ ev e1
  ( fn() =>
    let val n = #cnt (get_b buffer)
    in
      if n < 3 then buffer := Buffer{cnt=n+1} else ();
      act e1
    end
  ),
  ev e2
  ( fn() =>
    let val n = #cnt (get_b buffer)
    in
      if n > 0 then buffer := Buffer{cnt=n-1} else ();
      act e2
    end
  )
]

val _ = ( act e1; act e2 )

val print_comp = fn
  Buffer{cnt=n} => pr.printq `buffer(^(pr.d n))`

end
end 
